## jubatus-0.6.2.tar.gz

=== wscript ===
# -*- python -*-
import Options
from waflib.Errors import TaskNotReady
import os
import sys

VERSION = '0.6.2'
ABI_VERSION = VERSION
APPNAME = 'jubatus'

top = '.'
out = 'build'
subdirs = ['config', 'jubatus', 'plugin']

def options(opt):
  opt.load('compiler_cxx')
  opt.load('unittest_gtest')
  opt.load('gnu_dirs')

  opt.add_option('--enable-debug',
                 action='store_true', default=False,
                 dest='debug', help='build for debug')

  opt.add_option('--enable-zookeeper',
                 action='store_true', default=False, # dest='nozk',
                 help='use ZooKeeper')

  opt.add_option('--enable-gcov',
                 action='store_true', default=False,
                 dest='gcov', help='only for debug')

  opt.add_option('--enable-zktest',
                 action='store_true', default=False,
                 dest='zktest', help='zk should run in localhost:2181')

  # use (base + 10) ports for RPC module tests
  opt.add_option('--rpc-test-port-base',
                 default=60023, choices=map(str, xrange(1024, 65535 - 10)),
                 help='base port number for RPC module tests')

  opt.add_option('--disable-eigen',
                 action='store_true', default=False,
                 dest='disable_eigen', help='disable internal Eigen and algorithms using it')

  opt.add_option('--fsanitize',
                 action='store', default="",
                 dest='fsanitize', help='specify sanitizer')

  opt.recurse(subdirs)

def configure(conf):
  conf.env.CXXFLAGS += ['-O2', '-Wall', '-g', '-pipe', '-pthread'];
  conf.env.LINKFLAGS += ['-pthread']

  conf.load('compiler_cxx')
  conf.load('unittest_gtest')
  conf.load('gnu_dirs')

  # Generate config.hpp
  conf.env.JUBATUS_PLUGIN_DIR = conf.env['LIBDIR'] + '/jubatus/plugin'
  conf.define('JUBATUS_VERSION', VERSION)
  conf.define('JUBATUS_APPNAME', APPNAME)
  conf.define('JUBATUS_PLUGIN_DIR', conf.env.JUBATUS_PLUGIN_DIR)
  conf.write_config_header('jubatus/config.hpp', guard="JUBATUS_CONFIG_HPP_", remove=False)

  # Version constants
  conf.env.VERSION = VERSION
  conf.env.ABI_VERSION = ABI_VERSION

  conf.check_cxx(lib = 'msgpack')
  conf.check_cxx(lib = 'jubatus_mpio')
  conf.check_cxx(lib = 'jubatus_msgpack-rpc')
  conf.check_cxx(lib = 'dl')

  # pkg-config tests
  conf.find_program('pkg-config') # make sure that pkg-config command exists
  try:
    conf.check_cfg(package = 'liblog4cxx', args = '--cflags --libs')
    conf.check_cfg(package = 'jubatus_core', args = '--cflags --libs')
  except conf.errors.ConfigurationError:
    e = sys.exc_info()[1]
    conf.to_log("PKG_CONFIG_PATH: " + os.environ.get('PKG_CONFIG_PATH', ''))
    conf.fatal("Failed to find the library. Please confirm that PKG_CONFIG_PATH environment variable is correctly set.", e)

  conf.check_cxx(header_name = 'unistd.h')
  conf.check_cxx(header_name = 'sys/types.h')
  conf.check_cxx(header_name = 'sys/wait.h')
  conf.check_cxx(header_name = 'sys/stat.h')
  conf.check_cxx(header_name = 'cxxabi.h')
  conf.check_cxx(header_name = 'sys/socket.h net/if.h')
  conf.check_cxx(header_name = 'sys/ioctl.h')
  conf.check_cxx(header_name = 'fcntl.h')
  conf.check_cxx(header_name = 'netinet/in.h')
  conf.check_cxx(header_name = 'arpa/inet.h')
  conf.check_cxx(header_name = 'dlfcn.h')

  if not Options.options.debug:
    conf.define('NDEBUG', 1)
    conf.define('JUBATUS_DISABLE_ASSERTIONS', 1)

  if Options.options.enable_zookeeper:
    if (conf.check_cxx(header_name = 'c-client-src/zookeeper.h',
                           define_name = 'HAVE_ZOOKEEPER_H',
                           mandatory = False)):
      conf.define('ZOOKEEPER_HEADER', 'c-client-src/zookeeper.h')
    else:
      conf.check_cxx(header_name = 'zookeeper/zookeeper.h',
                     define_name = 'HAVE_ZOOKEEPER_H',
                     errmsg = 'ZooKeeper c-binding is not found. Please install c-binding.',
                     mandatory = True)
      conf.define('ZOOKEEPER_HEADER', 'zookeeper/zookeeper.h')

    conf.check_cxx(lib = 'zookeeper_mt', errmsg = 'ZK not found')

    if Options.options.zktest:
      conf.env.INTEGRATION_TEST = True

  if Options.options.gcov:
    conf.env.append_value('CXXFLAGS', '-fprofile-arcs')
    conf.env.append_value('CXXFLAGS', '-ftest-coverage')
    conf.env.append_value('LINKFLAGS', '-lgcov')

  if Options.options.rpc_test_port_base:
    conf.define('JUBATUS_RPC_TEST_PORT_BASE', int(Options.options.rpc_test_port_base))

  conf.define('BUILD_DIR',  conf.bldnode.abspath())

  conf.env.USE_EIGEN = not Options.options.disable_eigen
  if conf.env.USE_EIGEN:
    conf.define('JUBATUS_USE_EIGEN', 1)

  sanitizer_names = Options.options.fsanitize
  if len(sanitizer_names) > 0:
    conf.env.append_unique('CXXFLAGS', '-fsanitize=' + sanitizer_names)
    conf.env.append_unique('LINKFLAGS', '-fsanitize=' + sanitizer_names)

  conf.recurse(subdirs)

def build(bld):

  bld(source = 'jubatus.pc.in',
      prefix = bld.env['PREFIX'],
      exec_prefix = '${prefix}',
      libdir = bld.env['LIBDIR'],
      includedir = '${prefix}/include',
      PACKAGE = APPNAME,
      VERSION = VERSION)

  bld(source = 'jubatus-client.pc.in',
      prefix = bld.env['PREFIX'],
      exec_prefix = '${prefix}',
      libdir = bld.env['LIBDIR'],
      includedir = '${prefix}/include',
      PACKAGE = APPNAME,
      VERSION = VERSION)

  bld(name = 'server_headers', export_includes = './')
  bld(name = 'client_headers', export_includes = './')

  bld.recurse(subdirs)

  bld.install_files('${PREFIX}/share/jubatus/example/log', 'log4cxx.xml')

def cpplint(ctx):
  import fnmatch, tempfile
  cpplint = ctx.path.find_node('tools/codestyle/cpplint/cpplint.py')
  src_dir = ctx.path.find_node('jubatus')
  file_list = []
  excludes = ['jubatus/server/third_party/*',
              'jubatus/server/server/*_impl.cpp',
              'jubatus/server/server/*_proxy.cpp',
              'jubatus/server/server/*_client.hpp',
              'jubatus/server/server/*_types.hpp',
              'jubatus/client/*_client.hpp',
              'jubatus/client/*_types.hpp',
              'jubatus/core/third_party/*',
              'jubatus/util/*.h',
              'jubatus/util/*.cpp',
              'jubatus/util/*/*.h',
              'jubatus/util/*/*.cpp',
              'jubatus/util/*/*/*.h',
              'jubatus/util/*/*/*.cpp']
  for file in src_dir.ant_glob('**/*.cpp **/*.cc **/*.hpp **/*.h'):
    file_list += [file.path_from(ctx.path)]
  for exclude in excludes:
    file_list = [f for f in file_list if not fnmatch.fnmatch(f, exclude)]
  tmp_file = tempfile.NamedTemporaryFile(delete=True);
  tmp_file.write("\n".join(file_list));
  tmp_file.flush()
  ctx.exec_command('cat ' + tmp_file.name + ' | xargs "' + cpplint.abspath() + '" --filter=-runtime/references,-runtime/rtti 2>&1')
  tmp_file.close()

def regenerate(ctx):
  server_node = ctx.path.find_node('jubatus/server/server')
  jenerator_node = ctx.path.find_node('tools/jenerator/src/jenerator')
  if not jenerator_node:
    raise TaskNotReady('jenerator is not built yet')
  for idl_node in server_node.ant_glob('*.idl'):
    idl = idl_node.name
    service_name = os.path.splitext(idl)[0]
    jenerator_command = [jenerator_node.abspath(), '-l', 'server', '-o', '.', '-i', '-n', 'jubatus', '-g', 'JUBATUS_SERVER_SERVER_', idl]
    try:
      idl_hash = ctx.cmd_and_log(['git', 'log', '-1', '--format=%H', '--', idl], cwd=server_node.abspath()).strip()
      idl_ver = ctx.cmd_and_log(['git', 'describe', idl_hash], cwd=server_node.abspath()).strip()
      jenerator_command += ['--idl-version', idl_ver]
    except Exception:
      pass
    ctx.cmd_and_log(jenerator_command, cwd=server_node.abspath())
    print()
    if not service_name in ['graph', 'anomaly']:
      server_node.find_node('%s_client.hpp' % service_name).delete()

def regenerate_client(ctx):
  server_node = ctx.path.find_node('jubatus/server/server')
  client_node = ctx.path.find_node('jubatus/client')
  jenerator_node = ctx.path.find_node('tools/jenerator/src/jenerator')
  if not jenerator_node:
    raise TaskNotReady('jenerator is not built yet')
  for idl_node in server_node.ant_glob('*.idl'):
    idl = idl_node.name
    service_name = os.path.splitext(idl)[0]
    jenerator_command = [jenerator_node.abspath(), '-l', 'cpp', '-o', client_node.abspath(), '-i', '-n', 'jubatus::' + service_name, '-g', 'JUBATUS_CLIENT_', idl]
    try:
      idl_hash = ctx.cmd_and_log(['git', 'log', '-1', '--format=%H', '--', idl], cwd=server_node.abspath()).strip()
      idl_ver = ctx.cmd_and_log(['git', 'describe', idl_hash], cwd=server_node.abspath()).strip()
      jenerator_command += ['--idl-version', idl_ver]
    except Exception:
      pass
    ctx.cmd_and_log(jenerator_command, cwd=server_node.abspath())
    print()

def check_cmath(ctx):
  ctx.cmd_and_log('tools/codestyle/cmath_finder.sh')

=== plugin/src/wscript ===
# -*- python -*-
subdirs = 'fv_converter'

def options(opt):
    opt.recurse(subdirs)

def configure(conf):
    conf.recurse(subdirs)

def build(bld):
    bld.recurse(subdirs)

=== jubatus/server/cmd/wscript ===
def options(opt): pass

def configure(conf): pass

def build(bld):
  if bld.env.HAVE_ZOOKEEPER_H:
    bld.program(
      source = 'jubactl.cpp',
      target = 'jubactl',
      use = 'MSGPACK ZOOKEEPER_MT JUBATUS_CORE jubaserv_common jubaserv_common_logger jubaserv_framework JUBATUS_MPIO JUBATUS_MSGPACK-RPC MSGPACK'
      )

    bld.program(
      source = 'jubaconfig.cpp',
      target = 'jubaconfig',
      use = 'ZOOKEEPER_MT JUBATUS_CORE jubaserv_common jubaserv_common_logger'
      )


  bld.program(
    source = 'jubaconv.cpp',
    target = 'jubaconv',
    use = 'JUBATUS_CORE jubaserv_common'
    )

=== jubatus/server/common/wscript ===

subdirs = ['mprpc', 'logger']

def options(opt):
  opt.recurse(subdirs)

def configure(conf):
  conf.check_cxx(header_name = 'sys/socket.h net/if.h sys/ioctl.h', mandatory = True)
  conf.check_cxx(header_name = 'netinet/in.h arpa/inet.h', mandatory = True)

  # Check compiler(GCC/Clang) support atomic builtin extension
  conf.check_cxx(fragment='''
#include <stdint.h>
int main() {
  uint64_t c = 0;
  __sync_fetch_and_add(&c, 0);
  return 0;
}
''',
                 msg = 'Checking for compiler atomic builtins',
                 define_name = 'ATOMIC_I8_SUPPORT', mandatory = False)

  conf.recurse(subdirs)

def build(bld):
  import Options
  src = 'network.cpp global_id_generator_standalone.cpp config.cpp signals.cpp system.cpp filesystem.cpp crc32.cpp'

  if bld.env.HAVE_ZOOKEEPER_H:
    src += ' cached_zk.cpp zk.cpp membership.cpp cht.cpp lock_service.cpp global_id_generator_zk.cpp'

  bld.shlib(
    source = src,
    target = 'jubaserv_common',
    includes = '.',
    use = 'ZOOKEEPER_MT JUBATUS_CORE jubaserv_common_logger',
    vnum = bld.env['ABI_VERSION'],
    )

  test_src = [
    'network_test.cpp',
    'global_id_generator_test.cpp',
    'unique_lock_test.cpp',
    'crc32_test.cpp',
    'system_test.cpp',
    'filesystem_test.cpp',
    ]

  if bld.env.HAVE_ZOOKEEPER_H:
    test_src += ['membership_test.cpp', 'cht_test.cpp']
    if bld.env.INTEGRATION_TEST:
      test_src += ['zk_test.cpp', 'cached_zk_test.cpp', 'config_test.cpp']

  def make_test(s):
    bld.program(
      features = 'gtest',
      source = s,
      target = s[0:s.rfind('.')],
      includes = '.',
      use = ['JUBATUS_CORE', 'jubaserv_common']
      )
  for s in test_src:
    make_test(s)

  bld.install_files('${PREFIX}/include/jubatus/server/common/', [
      'cht.hpp',
      'config.hpp',
      'global_id_generator_base.hpp',
      'global_id_generator_standalone.hpp',
      'global_id_generator_zk.hpp',
      'lock_service.hpp',
      'membership.hpp',
      'crc32.hpp',
      'network.hpp',
      'signals.hpp',
      'unique_lock.hpp',
      'system.hpp',
      'filesystem.hpp',
      ])
  bld.recurse(subdirs)

=== jubatus/server/framework/wscript ===
# -*- python -*-
subdirs = 'mixer'

def options(opt):
  opt.recurse(subdirs)

def configure(conf):
  conf.recurse(subdirs)

def build(bld):
  bld.recurse(subdirs)

  framework_source = 'save_load.cpp server_util.cpp server_base.cpp server_helper.cpp'
  if bld.env.HAVE_ZOOKEEPER_H:
    framework_source +=  ' proxy_common.cpp proxy.cpp'

  bld.shlib(
    source = framework_source,
    target = 'jubaserv_framework',
    includes = '.',
    use = 'JUBATUS_CORE MSGPACK JUBATUS_MPIO JUBATUS_MSGPACK_RPC MSGPACK jubaserv_mixer jubaserv_common jubaserv_common_mprpc jubaserv_common_logger',
    vnum = bld.env['ABI_VERSION'],
    )

  def make_test(t):
    bld.program(
      features='gtest',
      source=t + '.cpp',
      target=t,
      includes='.',
      use='jubaserv_framework'
      )

  header_files = [
    'save_load.hpp',
    'server_base.hpp',
    'server_helper.hpp',
    'server_util.hpp',
  ]
  if bld.env.HAVE_ZOOKEEPER_H:
    header_files += [
      'proxy.hpp',
      'proxy_common.hpp',
      'aggregators.hpp'
    ]

  bld.install_files('${PREFIX}/include/jubatus/server/framework', header_files)

=== jubatus/server/fv_converter/wscript ===

def options(opt):
  pass

def configure(conf):
  libpat = conf.env.cxxshlib_PATTERN
  conf.define('LIBSPLITTER_SAMPLE', './' + libpat % 'splitter_sample')
  conf.define('LIBSPLITTER_NULL', './' + libpat % 'splitter_null')
  conf.define('LIBFILTER_SAMPLE', './' + libpat % 'filter_sample')
  conf.define('LIBNUM_FEATURE_SAMPLE', './' + libpat % 'num_feature_sample')
  conf.define('LIBNUM_FILTER_SAMPLE', './' + libpat % 'num_filter_sample')
  conf.define('LIBBINARY_FEATURE_SAMPLE', './' + libpat % 'binary_feature_sample')
  pass

def build(bld):
  import Options
  src = [
      'so_factory.cpp',
      'dynamic_loader.cpp',
      'dynamic_string_feature.cpp',
      'dynamic_num_feature.cpp',
      'dynamic_binary_feature.cpp',
      'dynamic_string_filter.cpp',
      'dynamic_num_filter.cpp',
      ]

  bld.shlib(
    source = src,
    target = 'jubaserv_fv_converter',
    includes = '.',
    use = 'JUBATUS_CORE ZOOKEEPER_MT DL jubaserv_common jubaserv_common_logger',
    vnum = bld.env['ABI_VERSION'],
    )

  # Note: If you specify `vnum` for shared libraries
  #       whose install_path = None, waf cause an error
  #       when doing ./waf install.

  bld.shlib(
    source = 'test_splitter.cpp',
    target = 'splitter_sample',
    install_path = None,
    name = 'splitter_sample',
    use = 'JUBATUS_CORE jubaserv_fv_converter'
    )

  bld.shlib(
    source = 'test_splitter_null.cpp',
    target = 'splitter_null',
    install_path = None,
    name = 'splitter_null',
    use = 'JUBATUS_CORE jubaserv_fv_converter'
    )

  bld.shlib(
    source = 'test_num_feature.cpp',
    target = 'num_feature_sample',
    install_path = None,
    name = 'num_feature_sample',
    use = 'JUBATUS_CORE jubaserv_fv_converter'
    )

  bld.shlib(
    source = 'test_num_filter.cpp',
    target = 'num_filter_sample',
    install_path = None,
    name = 'num_filter_sample',
    use = 'JUBATUS_CORE jubaserv_fv_converter'
    )

  bld.shlib(
    source = 'test_binary_feature.cpp',
    target = 'binary_feature_sample',
    install_path = None,
    name = 'binary_feature_sample',
    use = 'JUBATUS_CORE jubaserv_fv_converter'
    )

  bld.shlib(
    source = 'test_string_filter.cpp',
    target = 'filter_sample',
    install_path = None,
    name = 'filter_sample',
    use = 'JUBATUS_CORE jubaserv_fv_converter'
    )

  test_src = [
      'dynamic_loader_test.cpp',
      'dynamic_string_feature_test.cpp',
      'dynamic_num_feature_test.cpp',
      'dynamic_binary_feature_test.cpp',
      'dynamic_string_filter_test.cpp',
      'dynamic_num_filter_test.cpp',
      'so_factory_test.cpp',
    ]

  def make_test(s):
    bld.program(
      features = 'gtest',
      source = s,
      target = s[0:s.rfind('.')],
      includes = '.',
      use = ['jubaserv_fv_converter']
      )
  for s in test_src:
    make_test(s)

  bld.install_files('${PREFIX}/include/jubatus/server/fv_conveter/', [
      ])

=== jubatus/server/server/wscript ===
idls = ['classifier.idl', 'regression.idl', 'recommender.idl', 'stat.idl', 'graph.idl', 'anomaly.idl', 'clustering.idl']

def options(opt):
  pass

def configure(conf):
  if conf.env.HAVE_ZOOKEEPER_H:
    conf.check_cxx(msg = 'Checking for compiler TLS extension support',
                   fragment='__thread int i; int main() { return 0; }',
                   errmsg = 'no (Jubatus officially support GCC 4.4 or later)')


def build_one(bld, name, libraries = '', sources = ''):
  __sources = '%s_impl.cpp %s_serv.cpp ' % (name, name)
  __sources += sources

  bld.program(
    source = __sources,
    target = 'juba'+name,
    includes = '.',
    use = 'JUBATUS_CORE client_headers jubaserv_framework jubaserv_fv_converter jubaserv_common jubaserv_mprpc_common %s JUBATUS_MPIO JUBATUS_MSGPACK-RPC MSGPACK' % libraries
    )
  if bld.env.HAVE_ZOOKEEPER_H:
    bld.program(
      source = '%s_proxy.cpp ' % name,
      target = 'juba%s_proxy' % name,
      includes = '.',
      use = 'JUBATUS_CORE jubaserv_framework jubaserv_fv_converter jubaserv_common jubaserv_mprpc_common JUBATUS_MPIO JUBATUS_MSGPACK-RPC MSGPACK'
      )

def build(bld):
  build_one(bld, "classifier")
  build_one(bld, "regression")
  build_one(bld, "recommender")
  build_one(bld, "anomaly")
  build_one(bld, "stat")
  build_one(bld, "graph")
  build_one(bld, "nearest_neighbor")
  build_one(bld, "clustering")

  bld.install_files('${PREFIX}/share/jubatus/idl/', idls)

=== jubatus/server/common/mprpc/wscript ===

def options(opt): pass

def configure(conf): pass

def build(bld):
  src = 'rpc_mclient.cpp rpc_server.cpp'

  bld.shlib(
    source = src,
    target = 'jubaserv_common_mprpc',
    use = 'ZOOKEEPER_MT JUBATUS_MPIO JUBATUS_MSGPACK-RPC MSGPACK JUBATUS_CORE jubaserv_common_logger',
    vnum = bld.env['ABI_VERSION'],
    )

  bld.program(
    features = 'gtest',
    source = 'rpc_client_test.cpp',
    target = 'rpc_client_test',
    includes = '.',
    use = 'JUBATUS_MPIO JUBATUS_MSGPACK-RPC MSGPACK JUBATUS_CORE jubaserv_common_mprpc',
    )

  bld.install_files('${PREFIX}/include/jubatus/server/common/mprpc', bld.path.ant_glob('*.hpp'))

=== tools/packaging/allinone/metadata/debian/control ===
Source: jubatus
Priority: extra
Maintainer: PFI & NTT <jubatus@googlegroups.com>
Build-Depends: debhelper (>= 8.0.0), autotools-dev, pkg-config, python (>= 2.6), liblog4cxx10-dev
Standards-Version: 3.9.3
Section: misc
Homepage: http://jubat.us/

Package: jubatus
Section: misc
Architecture: any
Depends: libc6 (>= 2.14), liblog4cxx10, ${misc:Depends}
Description: Distributed processing framework and streaming machine learning library
 Jubatus is a distributed processing framework and streaming machine
 learning library.
